
//------------------------------------------------------------------------------------------
// BUILD (07.03.2009) Tebe/Madteam
// program modyfikujacy plik EXE, dopisuje numer wersji na podstawie pliku *.INF
//------------------------------------------------------------------------------------------

program build;

{$APPTYPE CONSOLE}

uses
  SysUtils, HTTPApp, StrUtils;

var
  t: textfile;

  iFileHandle: Integer;
  iFileLength: Integer;
  iBytesRead: Integer;
  Buffer: PChar;

  i, j: integer;

  all, dat, ver, mrk, bld, eol, fname, finfo, stext, eline: string;

const
  maxLength = 32;


function DecodeString(m: string): string;
var i: integer;
    c: char;
    digit: string;
begin

 Result:='';

 i:=1;
 while i<=length(m) do begin

  c:=m[i];

  if c='#' then begin
   inc(i);
   digit:='';
   while m[i] in ['0'..'9'] do begin digit:=digit+m[i]; inc(i) end;

   c:=chr(StrToInt(digit));
  end else
   inc(i);

  Result:=Result+c;
 end;


end;


function Find(const search: string): integer;
var i, j, len: integer;
    str: string;
begin
      Result:=-1;

      len:=length(search);

      i:=0;
      while i<iBytesRead-len do begin

       if Buffer[i]=search[1] then begin
        str:='';
        for j:=0 to len-1 do str:=str+Buffer[i+j];

        if str=search then begin Result:=i + len; Break end;
       end;

       inc(i);
      end;
end;


procedure MarkerSyntax;
begin
 writeln('Example info_file: ');
 writeln('#128#128string#155#13#10');
 writeln('#155');
 writeln('v1.0');
 writeln('0');
 halt;
end;


procedure Syntax;
begin
 writeln('build 1.1');
 writeln('Syntax: build input_file [-i:info_file]');
 MarkerSyntax;
 halt;
end;


procedure FileNotFound(var name: string);
begin
 writeln('File '+''''+name+''''+' not found.');
 halt;
end;


begin

 if ParamCount<1 then
  Syntax
 else begin

  for i:=1 to ParamCount do
   if ParamStr(i)[1]<>'-' then
    fname:=ParamStr(i)
   else
    case UpCase(ParamStr(i)[2]) of
     'I': finfo:=copy(ParamStr(i),4,length(ParamStr(i)));
    else
     Syntax
    end;
           
 end;


 if fname='' then Syntax;

 if finfo='' then finfo:=ChangeFileExt(fname,'.inf');

 if not(FileExists(finfo)) then FileNotFound(finfo);
 if not(FileExists(fname)) then FileNotFound(fname);


 assignfile(t, finfo); reset(t);
 readln(t, mrk);
 readln(t, eol);
 readln(t, ver);
 readln(t, bld);
 closefile(t);

 stext:=DecodeString(mrk);
 eline:=DecodeString(eol);


 if (stext='') or (length(stext)>=32) then begin
  MarkerSyntax;
  halt;
 end;

      iFileHandle := FileOpen(fname, fmOpenRead);
      iFileLength := FileSeek(iFileHandle,0,2);
      FileSeek(iFileHandle,0,0);
      Buffer := PChar(AllocMem(iFileLength + 1));
      iBytesRead := FileRead(iFileHandle, Buffer^, iFileLength);

      FileClose(iFileHandle);

      i:=Find(stext);

      if i<0 then begin
       writeln('Marker ','''',mrk,'''',' not found.');

       FreeMem(Buffer);
       halt;
      end;

      
 bld:=IntToStr(StrToInt(bld)+1);       // build ++


 assignfile(t, finfo); rewrite(t);
 writeln(t, mrk);
 writeln(t, eol);
 writeln(t, ver);
 writeln(t, bld);
 closefile(t);


 ShortDateFormat := 'd';
 dat:='('+DateToStr(Date)+' '+MonthStr(Date);
 ShortDateFormat := 'y';
 dat:=dat+' '+DateToStr(Date)+')';

 all:=ver+' build '+bld+' '+dat + eLine;

            
 if length(all)>maxLength then begin

  writeln(all);
  writeln;
  writeln('String too long (max=32).')

 end else begin

   while length(all)<maxLength do all:=all+' ';

   for j:=0 to maxLength-1 do Buffer[i+j]:=all[j+1];

   iFileHandle := FileCreate(fname);
   FileWrite(iFileHandle, Buffer^, iFileLength);
   FileClose(iFileHandle);

 end;


 FreeMem(Buffer);

 writeln(all);
end.
